﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=12.5
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: True
	
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Private lock As PhoneWakeState
	Private nid As Int = 1
	Private doneList As List
End Sub

Sub Service_Create
	Service.AutomaticForegroundMode = Service.AUTOMATIC_FOREGROUND_NEVER
	lock.PartialLock
	Dim url As String = "link to GetList.php"
	Dim url2 As String = "link to sms_sent.php"
	Dim job,job2 As HttpJob
	Dim toSend As String
	Dim sms_service As PhoneSms
	Dim returned_array_1(), returned_array_2() As String
	job.Initialize("", Me)
	job2.Initialize("",Me)
	Do While True
		toSend = ""
		job.Download(url)
		Wait For (job) JobDone(job As HttpJob)
		If job.Success Then
			toSend = job.GetString
			If toSend <> "" Then
				doneList.Initialize
				returned_array_1 = Regex.Split("\|\|\|",toSend)
				For i = 0 To returned_array_1.Length -1
					If returned_array_1(i) <> "" Then
						returned_array_2 = Regex.Split("\|\|",returned_array_1(i))
						Log("Send SMS : " & returned_array_2(2) & " --> " & returned_array_2(1))
						sms_service.Send(returned_array_2(2),returned_array_2(1))
						doneList.Add(returned_array_2(0))
					End If
				Next
				Dim doneString As String
				doneString = JoinStrings(doneList, ",")
				Dim params As Map
				params.Initialize
				params.Put("doneList", doneString)
				job.PostString(url2, CreatePostData(params))
			Else
				Log("I don't have anything to send !")
			End If
		End If
		job.Release
		CreateNotification("Still running " & DateTime.Time(DateTime.Now)).Notify(1800)
		Sleep(60000) ' change by 300000 in the final version
	Loop
	'StartServiceAt(Starter, DateTime.Now + 30, True)
End Sub

' Join a list of strings with a given delimiter
Sub JoinStrings(list As List, delimiter As String) As String
	Dim sb As StringBuilder
	sb.Initialize
	For i = 0 To list.Size - 1
		If i > 0 Then sb.Append(delimiter)
		sb.Append(list.Get(i))
	Next
	Return sb.ToString
End Sub

' Create a POST data string from a Map
Sub CreatePostData(params As Map) As String
	Dim sb As StringBuilder
	sb.Initialize
	For Each key As String In params.Keys
		If sb.Length > 0 Then sb.Append("&")
		sb.Append(key).Append("=").Append(params.Get(key))
	Next
	Return sb.ToString
End Sub

Sub Service_Start (StartingIntent As Intent)
	Service.StartForeground(nid, CreateNotification("Running in background"))

	'Service.StopAutomaticForeground 'Call this when the background task completes (if there is one)
End Sub

Sub Service_Destroy

End Sub

Sub CreateNotification (Body As String) As Notification
	Dim notification As Notification
	notification.Initialize2(notification.IMPORTANCE_LOW)
	notification.Icon = "icon"
	notification.SetInfo("SMSSender", Body, Main)
	Return notification
End Sub
